import type { AbstractControl } from './abstract-control';
export interface ValidationErrors {
    [key: string]: any;
}
export type ValidatorFn = (control: AbstractControl) => ValidationErrors | null;
export type AsyncValidatorFn = (control: AbstractControl) => Promise<ValidationErrors | null>;
export declare class Validators {
    static min(min: number): ValidatorFn;
    static max(max: number): ValidatorFn;
    static required(control: AbstractControl): ValidationErrors | null;
    static email(control: AbstractControl): ValidationErrors | null;
    static minLength(minLength: number): ValidatorFn;
    static maxLength(maxLength: number): ValidatorFn;
    static pattern(pattern: string | RegExp): ValidatorFn;
}
