import type { DId } from '../../utils/types';
import type { ComboboxKeyDownRef } from '../_keyboard';
import type { DTreeItem } from './Tree';
import type { AbstractTreeNode, TreeOrigin } from './abstract-node';
import React from 'react';
import { TREE_NODE_KEY } from './utils';
export type DSearchItem<V extends DId, T extends TreeOrigin> = DTreeItem<V> & {
    [TREE_NODE_KEY]: AbstractTreeNode<V, T>;
};
interface DSearchPanelProps<V extends DId, T extends DTreeItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dGetItemId: (value: V) => string;
    dList: DSearchItem<V, T>[];
    dFocusItem: DSearchItem<V, T> | undefined;
    dCustomItem: ((item: T) => React.ReactNode) | undefined;
    dMultiple: boolean;
    dOnlyLeafSelectable?: boolean;
    dFocusVisible: boolean;
    onFocusChange: (item: DSearchItem<V, T>) => void;
    onClickItem: (item: DSearchItem<V, T>) => void;
}
declare function SearchPanel<V extends DId, T extends DTreeItem<V>>(props: DSearchPanelProps<V, T>, ref: React.ForwardedRef<ComboboxKeyDownRef>): JSX.Element | null;
export declare const DSearchPanel: <V extends DId, T extends DTreeItem<V>>(props: DSearchPanelProps<V, T> & React.RefAttributes<ComboboxKeyDownRef>) => ReturnType<typeof SearchPanel>;
export {};
